// SPDX-License-Identifier: GPL-2.0 OR MIT
/*
 * Copyright (C) 2024 MediaTek INC.
 * Author: Macpaul Lin <macpaul.lin@mediatek.com>
 */

/dts-v1/;

#include <config.h>
#include "mt8188.dtsi"

/ {
	model = "MediaTek Genio-700 EVK with QSPI NOR Flash storage";
	compatible = "mediatek,genio-700-evk-qspi", "mediatek,mt8188";

	smbios {
		compatible = "u-boot,sysinfo-smbios";
		smbios {
				system {
						manufacturer = "MediaTek";
						product = "Genio 700 EVK P1V4 (SPI NOR Boot)";
						version = "P1V4-A";
						sku = "mtk-g700evkqspi-p1v4";
						family = "MediaTek Genio";
				};
				baseboard {
						manufacturer = "MediaTek";
						product = "Genio 700 EVK P1V4 (SPI NOR Reworked)";
				};
				chassis {
						manufacturer = "MediaTek";
				};
		};
	};

	memory@40000000 {
		/* 8GB */
		device_type = "memory";
		reg = <0 0x40000000 2 0x00000000>;
	};

	firmware: firmware {
		optee {
			compatible = "linaro,optee-tz";
			method = "smc";
		};

		psci: psci {
			compatible = "arm,psci-1.0";
			method = "smc";
		};
	};

	reserved-memory {
		#address-cells = <2>;
		#size-cells = <2>;
		ranges;

		/* 2 MiB reserved for ARM Trusted Firmware (BL31) */
		bl31_secmon_reserved: secmon@54600000 {
			no-map;
			reg = <0 0x54600000 0x0 0x200000>;
		};

		/* 12 MiB reserved for OP-TEE (BL32)
		 * +-----------------------+ 0x43e0_0000
		 * |      SHMEM 2MiB       |
		 * +-----------------------+ 0x43c0_0000
		 * |        | TA_RAM  8MiB |
		 * + TZDRAM +--------------+ 0x4340_0000
		 * |        | TEE_RAM 2MiB |
		 * +-----------------------+ 0x4320_0000
		 */
		optee_reserved: optee@43200000 {
			no-map;
			reg = <0 0x43200000 0 0x00c00000>;
		};

		dsi_reserved: dsi@60000000 {
			reg = <0 0x60000000 0 0x02000000>;
			no-map;
		};
	};

	chosen {
		stdout-path = &uart0;
	};

	reg_1p8v: regulator-1p8v {
		compatible = "regulator-fixed";
		regulator-name = "fixed-1.8V";
		regulator-min-microvolt = <1800000>;
		regulator-max-microvolt = <1800000>;
		regulator-boot-on;
		regulator-always-on;
	};

	reg_3p3v: regulator-3p3v {
		compatible = "regulator-fixed";
		regulator-name = "fixed-3.3V";
		regulator-min-microvolt = <3300000>;
		regulator-max-microvolt = <3300000>;
		regulator-boot-on;
		regulator-always-on;
	};

	usbp0_vbus3v3: usbp0-vbus3v3 {
		compatible = "regulator-fixed";
		regulator-name = "usbp0-vbus3v3";
		regulator-min-microvolt = <3300000>;
		regulator-max-microvolt = <3300000>;
		gpio = <&gpio 84 GPIO_ACTIVE_HIGH>;
		enable-active-high;
	};

	usbp1_vbus3v3: usbp1-vbus3v3 {
		compatible = "regulator-fixed";
		regulator-name = "usbp1-vbus3v3";
		regulator-min-microvolt = <3300000>;
		regulator-max-microvolt = <3300000>;
		gpio = <&gpio 87 GPIO_ACTIVE_HIGH>;
		enable-active-high;
	};

	usbhub_3v3: usbhub-3v3 {
		compatible = "regulator-fixed";
		regulator-name = "usbhub-3v3";
		regulator-min-microvolt = <3300000>;
		regulator-max-microvolt = <3300000>;
		gpio = <&gpio 112 GPIO_ACTIVE_HIGH>;
		startup-delay-us = <10000>;
		enable-active-high;
	};

	usbhub_reset: usbhub-reset {
		compatible = "regulator-fixed";
		regulator-name = "usbhub-reset";
		regulator-min-microvolt = <1800000>;
		regulator-max-microvolt = <1800000>;
		gpio = <&gpio 7 GPIO_ACTIVE_HIGH>;
		enable-active-low;
	};

	dsi0: dsi0{
		compatible = "mediatek,mt8188-dsi";
		reg = <0 0x60000000 0 0x02000000>;
		pinctrl-names = "default";
		pinctrl-0 = <&panel_pins_default>;
		reset-gpios = <&gpio 25 GPIO_ACTIVE_HIGH>;
		dcdc-gpios = <&gpio 45 GPIO_ACTIVE_HIGH>;
		enable-gpios = <&gpio 111 GPIO_ACTIVE_HIGH>;
		status = "okay";
	};

	edp_tx: edp-tx@1c500000 {
		compatible = "mediatek,mt8188-edp-tx";
		reg = <0 0x60000000 0 0x02000000>;
		pinctrl-names = "default";
		pinctrl-0 = <&edp_pin_default>;
		vcc-gpios = <&gpio 15 GPIO_ACTIVE_HIGH>;
		bl-en-gpios = <&gpio 8 GPIO_ACTIVE_HIGH>;
		pwm-gpios = <&gpio 29 GPIO_ACTIVE_HIGH>;
		status = "disabled";
	};
};

&watchdog {
	status = "okay";
};

&uart0 {
	status = "okay";
};

&mmc0 {
	bus-width = <8>;
	max-frequency = <200000000>;
	cap-mmc-highspeed;
	mmc-hs200-1_8v;
	mmc-hs400-1_8v;
	hs400-ds-delay = <0x1481b>;
	cap-mmc-hw-reset;
	vmmc-supply = <&reg_3p3v>;
	vqmmc-supply = <&reg_1p8v>;
	non-removable;
	status = "okay";
};

&mmc1 {
	pinctrl-names = "default";
	pinctrl-0 = <&mmc1_pins_default>;
	bus-width = <4>;
	max-frequency = <52000000>;
	cap-sd-highspeed;
	cd-gpios = <&pio 2 GPIO_ACTIVE_LOW>;
	vmmc-supply = <&reg_3p3v>;
	vqmmc-supply = <&reg_3p3v>;
	status = "okay";
};

&snor {
	pinctrl-names = "default";
	pinctrl-0 = <&snor_pins>;
	status = "okay";

	spi-flash@0{
		compatible = "jedec,spi-nor";
		reg = <0>;
		#spi-tx-bus-width = <1>;
		#spi-rx-bus-width = <4>;
		#u-boot,dm-pre-reloc;
	};
};

&i2c0 {
	pinctrl-names = "default";
	pinctrl-0 = <&i2c0_pin>;
	clock-frequency = <400000>;
	status = "okay";
};

&i2c1 {
	pinctrl-names = "default";
	pinctrl-0 = <&i2c1_pin>;
	clock-frequency = <400000>;
	status = "okay";
};

&i2c2 {
	pinctrl-names = "default";
	pinctrl-0 = <&i2c2_pin>;
	clock-frequency = <400000>;
	status = "okay";
};

&i2c3 {
	pinctrl-names = "default";
	pinctrl-0 = <&i2c3_pin>;
	clock-frequency = <400000>;
	status = "okay";
};

&i2c4 {
	pinctrl-names = "default", "default";
	pinctrl-0 = <&i2c4_pin>;
	clock-frequency = <400000>;
	status = "okay";
};

&i2c5 {
	pinctrl-names = "default";
	pinctrl-0 = <&i2c5_pin>;
	clock-frequency = <400000>;
	status = "okay";
};

&i2c6 {
	pinctrl-names = "default";
	pinctrl-0 = <&i2c6_pin>;
	clock-frequency = <400000>;
	status = "okay";
};

&u3phy0 {
	status = "okay";
};

&u3phy1 {
	status = "okay";
};

&u3phy2 {
	status = "okay";
};

&u2port0 {
	status = "okay";
};

&u2port1 {
	status = "okay";
};

&u3port1 {
	status = "okay";
};

&u2port2 {
	status = "okay";
};

&usb {
	vbus-supply = <&usbp0_vbus3v3>;
	status = "okay";
};

&ssusb {
	mediatek,force-vbus;
	maximum-speed = "high-speed";
	dr_mode = "peripheral";
	status = "okay";
};

&xhci1 {
	pinctrl-0 = <&usb1_default>;
	pinctrl-names = "default";
	vusb33-supply = <&usbhub_3v3>;
	vbus-supply = <&usbhub_reset>;
	status = "okay";
};

&pio {
	i2c0_pin: i2c0-pin {
		pins-bus {
			pinmux = <PINMUX_GPIO56__FUNC_B1_SDA0>,
				 <PINMUX_GPIO55__FUNC_B1_SCL0>;
			bias-pull-up = <MTK_PULL_SET_RSEL_011>;
			mediatek,drive-strength-adv = <7>;
		};
	};

	i2c1_pin: i2c1-pin {
		pins-bus {
			pinmux = <PINMUX_GPIO58__FUNC_B1_SDA1>,
				 <PINMUX_GPIO57__FUNC_B1_SCL1>;
			bias-pull-up = <MTK_PULL_SET_RSEL_011>;
			mediatek,drive-strength-adv = <7>;
		};
	};

	i2c2_pin: i2c2-pin {
		pins-bus {
			pinmux = <PINMUX_GPIO60__FUNC_B1_SDA2>,
				 <PINMUX_GPIO59__FUNC_B1_SCL2>;
			bias-pull-up = <MTK_PULL_SET_RSEL_011>;
			mediatek,drive-strength-adv = <7>;
		};
	};

	i2c3_pin: i2c3-pin {
		pins-bus {
			pinmux = <PINMUX_GPIO62__FUNC_B1_SDA3>,
				 <PINMUX_GPIO61__FUNC_B1_SCL3>;
			bias-pull-up = <MTK_PULL_SET_RSEL_011>;
			mediatek,drive-strength-adv = <7>;
		};
	};

	i2c4_pin: i2c4-pin {
		pins-bus {
			pinmux = <PINMUX_GPIO64__FUNC_B1_SDA4>,
				 <PINMUX_GPIO63__FUNC_B1_SCL4>;
			bias-pull-up = <MTK_PULL_SET_RSEL_011>;
			mediatek,drive-strength-adv = <7>;
		};
	};

	i2c5_pin: i2c5-pin {
		pins-bus {
			pinmux = <PINMUX_GPIO66__FUNC_B1_SDA5>,
				 <PINMUX_GPIO65__FUNC_B1_SCL5>;
			bias-pull-up = <MTK_PULL_SET_RSEL_011>;
			mediatek,drive-strength-adv = <7>;
		};
	};

	i2c6_pin: i2c6-pin {
		pins-bus {
			pinmux = <PINMUX_GPIO68__FUNC_B1_SDA6>,
				 <PINMUX_GPIO67__FUNC_B1_SCL6>;
			bias-pull-up = <MTK_PULL_SET_RSEL_011>;
			mediatek,drive-strength-adv = <7>;
		};
	};

	usb1_default: usbp1default {
		vbus-pins {
			pinmux = <PINMUX_GPIO87__FUNC_O_USB_DRVVBUS_1P>;
			output-high;
		};
	};

	panel_pins_default: panel-pins-default {
		panel-dcdc {
			pinmux = <PINMUX_GPIO45__FUNC_B_GPIO45>;
			output-low;
		};

		panel-en {
			pinmux = <PINMUX_GPIO111__FUNC_B_GPIO111>;
			output-low;
		};

		panel-rst {
			pinmux = <PINMUX_GPIO25__FUNC_B_GPIO25>;
			output-high;
		};

		pins-bl {
			pinmux = <PINMUX_GPIO30__FUNC_O_DISP_PWM1>;
		};
	};

	edp_pin_default: edp-pin-default {
		edp-panel-vcc {
			pinmux = <PINMUX_GPIO15__FUNC_B_GPIO15>;
			output-low;
		};

		edp-panel-hpd {
			pinmux = <PINMUX_GPIO17__FUNC_I0_EDP_TX_HPD>;
			bias-pull-up;
		};

		edp-panel-bl-en {
			pinmux = <PINMUX_GPIO8__FUNC_B_GPIO8>;
			output-low;
		};

		edp-panel-pwm {
			pinmux = <PINMUX_GPIO29__FUNC_O_DISP_PWM0>;
			output-low;
		};
	};

	mmc1_pins_default: mmc1default {
		pins-cmd-dat {
			pinmux = <PINMUX_GPIO163__FUNC_B1_MSDC1_CMD>,
				 <PINMUX_GPIO165__FUNC_B1_MSDC1_DAT0>,
				 <PINMUX_GPIO166__FUNC_B1_MSDC1_DAT1>,
				 <PINMUX_GPIO167__FUNC_B1_MSDC1_DAT2>,
				 <PINMUX_GPIO168__FUNC_B1_MSDC1_DAT3>;
			input-enable;
			drive-strength = <MTK_DRIVE_6mA>;
			bias-pull-up = <MTK_PUPD_SET_R1R0_01>;
		};

		pins-clk {
			pinmux = <PINMUX_GPIO164__FUNC_B1_MSDC1_CLK>;
			drive-strength = <MTK_DRIVE_6mA>;
			bias-pull-down = <MTK_PUPD_SET_R1R0_10>;
		};

		pins-insert {
			pinmux = <PINMUX_GPIO2__FUNC_B_GPIO2>;
			bias-pull-up;
		};
	};

	snor_pins: snor-pins {
		pins0 {
			pinmux = <PINMUX_GPIO127__FUNC_B0_SPINOR_IO0>,
				 <PINMUX_GPIO125__FUNC_O_SPINOR_CK>,
				 <PINMUX_GPIO128__FUNC_B0_SPINOR_IO1>;
			drive-strength = <MTK_DRIVE_8mA>;
			bias-pull-down;
		};

		pins1 {
			pinmux = <PINMUX_GPIO126__FUNC_O_SPINOR_CS>,
				 <PINMUX_GPIO129__FUNC_B0_SPINOR_IO2>,
				 <PINMUX_GPIO130__FUNC_B0_SPINOR_IO3>;
			drive-strength = <MTK_DRIVE_8mA>;
			bias-pull-up;
		};
	};
};

&auxadc {
	status = "okay";
};
